(function(e, a) { for(var i in a) e[i] = a[i]; }(exports, /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 3);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "logThis", function() { return logThis; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "log", function() { return log; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "capitalize", function() { return capitalize; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "concat", function() { return concat; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "eachBackwards", function() { return eachBackwards; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "takeFirst", function() { return takeFirst; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "stripSuffix", function() { return stripSuffix; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "inputBaseType", function() { return inputBaseType; });
function logThis() {
  console.log(this)
}

function log(...args) {
  args.pop() // remove handlebars metadata
  console.log(...args)
}

function capitalize(lower) {
  return lower.replace(/^\w/, c => c.toUpperCase())
}

function concat(...args) {
  return args.slice(0, -1).join('')
}

function eachBackwards(context, options) {
  var ret = ''

  for (var i = context.length - 1, j = 0; i >= j; i--) {
    ret = ret + options.fn(context[i])
  }

  return ret
}

function takeFirst(arg, b) {
  if (arg !== null && arg !== undefined) {
    return arg
  }
  return b
}

function stripSuffix(name, suffix) {
  return name.replace(
    new RegExp(suffix + '$'), ''
  )
}

function inputBaseType(name) {
  return stripSuffix(name, 'Input')
}


/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("handlebars");

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "shouldBeIncluded", function() { return shouldBeIncluded; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return fragmentFieldOnBaseType; });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);


const fragmentClass = f => Object(_utils__WEBPACK_IMPORTED_MODULE_0__["capitalize"])(f.fragmentName)

const builtinInterfaces = ['ToJson']

function shouldBeIncluded(fieldName, config){
  for (let exclude of config.excludeFields || []){
    if (typeof exclude === 'string'){
      if (exclude === fieldName){
        return false
      }
    } else {
      const { prefix, suffix } = exclude || {}
      if (
        (prefix && fieldName.startsWith(prefix)) ||
        (suffix && fieldName.endsWith(suffix))
      ) {
        return false
      }
    }
  }
  return true
}

// TODO stopgap for https://github.com/dotansimha/graphql-code-generator/issues/847
function fragmentFieldOnBaseType(fieldName, config) {
  if (!config){
    return false
  }
  if (config === true) {
    return true
  }
  return shouldBeIncluded(fieldName, config)
}



/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_codegen_core_1 = __webpack_require__(4);
var graphql_codegen_plugin_helpers_1 = __webpack_require__(5);
var Handlebars = __webpack_require__(1);
// Import partials
var templates_1 = __webpack_require__(6);
// Import helpers
var helpers_1 = __webpack_require__(15);
exports.plugin = function (schema, documents) { return __awaiter(_this, void 0, void 0, function () {
    var transformedDocuments, files;
    return __generator(this, function (_a) {
        transformedDocuments = graphql_codegen_core_1.transformDocumentsFiles(schema, documents);
        files = graphql_codegen_plugin_helpers_1.buildFilesArray(transformedDocuments);
        Handlebars.registerPartial('defineClass', templates_1.defineClass);
        Handlebars.registerPartial('fragment', templates_1.fragment);
        Handlebars.registerPartial('enum', templates_1.enum);
        Handlebars.registerPartial('operation', templates_1.operation);
        Handlebars.registerPartial('type', templates_1.type);
        Handlebars.registerPartial('schema', templates_1.schema);
        Handlebars.registerPartial('documents', templates_1.documents);
        Handlebars.registerPartial('index', templates_1.index);
        Handlebars.registerHelper('log', helpers_1.log);
        Handlebars.registerHelper('logThis', helpers_1.logThis);
        Handlebars.registerHelper('concat', helpers_1.concat);
        Handlebars.registerHelper('eachBackwards', helpers_1.eachBackwards);
        Handlebars.registerHelper('takeFirst', helpers_1.takeFirst);
        Handlebars.registerHelper('stripSuffix', helpers_1.stripSuffix);
        Handlebars.registerHelper('multilineComment', helpers_1.multilineComment);
        Handlebars.registerHelper('classExtends', helpers_1.classExtends);
        Handlebars.registerHelper('resolveType', helpers_1.resolveType);
        Handlebars.registerHelper('resolveMixins', helpers_1.resolveMixins);
        Handlebars.registerHelper('hackFragmentFields', helpers_1.hackFragmentFields);
        Handlebars.registerHelper('ignoreType', helpers_1.ignoreType);
        Handlebars.registerHelper('withInputType', helpers_1.withInputType);
        Handlebars.registerHelper('registerInputType', helpers_1.registerInputType);
        Handlebars.registerHelper('fragmentFieldOnBaseType', helpers_1.fragmentFieldOnBaseType);
        return [2 /*return*/, Handlebars.compile(templates_1.index)({ files: files })];
    });
}); };
exports.validate = function (schema, documents, config, outputFile) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/];
    });
}); };


/***/ }),
/* 4 */
/***/ (function(module, exports) {

module.exports = require("graphql-codegen-core");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

module.exports = require("graphql-codegen-plugin-helpers");

/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var defineClass = __webpack_require__(7);
exports.defineClass = defineClass;
var enumTemplate = __webpack_require__(8);
exports.enum = enumTemplate;
var type = __webpack_require__(9);
exports.type = type;
var fragment = __webpack_require__(10);
exports.fragment = fragment;
var operation = __webpack_require__(11);
exports.operation = operation;
var schema = __webpack_require__(12);
exports.schema = schema;
var documents = __webpack_require__(13);
exports.documents = documents;
var index = __webpack_require__(14);
exports.index = index;


/***/ }),
/* 7 */
/***/ (function(module, exports) {

module.exports = "@JsonSerializable()\nclass {{ className }} {{\n\n  classExtends\n    (resolveMixins @root.config.mixins fields)\n    fragmentsSpread\n    interfaces\n    @root.config.replaceTypes\n\n}} {\n  {{#if typeName }}\n  static final String typeName = \"{{ typeName }}\";\n  {{/if}}\n\n  {{#each fields}}{{#if type}}{{#if name}}\n  {{#if description }}{{ multilineComment description }}\n  {{/if}}\n  {{ resolveType type\n      (takeFirst contextName ../contextName)\n      (takeFirst contextModels ../contextModels)\n      @root.config.scalars\n      @root.config.replaceTypes\n      isArray\n      @root.config.irreducibleTypes\n      raw\n  }} {{name}};\n  {{~/if}}{{/if}}{{/each}}\n\n  {{className}}(\n  {{~#if fields.length~}}\n  {\n    {{#each fields}}{{#if name}}\n    {{~#if isRequired}}@required {{/if}}this.{{name}},\n    {{/if}}{{/each}}\n  }\n  {{~/if}});\n\n  {{ className }}.empty();\n\n\n  static I _assign<I extends {{className}}>(\n    I into,\n    {{className}} source,\n  ) {\n    {{~#each fields}}{{#if name}}\n    into.{{name}} = source.{{name}};\n    {{~/if}}{{/each}}\n    return into;\n  }\n\n  /// Modeled after javascript's Object.assign.\n  /// Copies the attributes from [source] into [target],\n  /// then optionally does the same for each item in [vargs]\n  static I assign<I extends {{className}}>(\n    I into,\n    {{className}} source,\n    [List<{{className}}> vargs]\n  ) {\n    into = _assign(into, source);\n    if (vargs != null){\n      vargs.forEach((varg){\n        into = _assign(into, varg);\n      });\n    }\n    return into;\n  }\n\n  {{#if assignableTo~}}\n  {{~#if @root.config.generateFragmentHelpers~}}\n  {{~#each assignableTo}}\n  /// Modeled after javascript's Object.assign.\n  /// Copies the attributes from [source] into [target]\n  static {{this}} assignTo{{ this }}(\n    {{this}} into,\n    {{../className}} source,\n  ){\n    {{~#each ../fields}}{{~#if (\n      fragmentFieldOnBaseType\n        name\n        @root.config.generateFragmentHelpers\n      )\n    }}\n    into.{{name}} = source.{{name}};\n    {{~/if}}{{/each}}\n    return into;\n  }\n  {{/each~}}\n  {{~/if}}{{~/if}}\n\n  /// Copies and downcasts any inheriting [source] into a new [{{className}}]\n  static {{className}} copy({{className}} source) {\n     return {{className}}(\n      {{~#each fields~}}{{#if name}}\n        {{name}}: source.{{name}},\n      {{~/if}}{{/each}}\n    );\n  }\n\n  factory {{className}}.fromJson(Map<String, dynamic> json) => _${{className}}FromJson(json);\n\n  Map<String, dynamic> toJson() => serializeToJson(this);\n\n  static const deserializeFromJson = _${{className}}FromJson;\n  {{#if typeName }}\n  static Map<String, dynamic> serializeToJson({{className}} instance){\n    Map<String, dynamic> json = _${{className}}ToJson(instance);\n    json['__typename'] = typeName;\n    return json;\n  }\n  {{else}}\n  static const serializeToJson = _${{className}}ToJson;\n  {{/if}}\n\n}\n\n"

/***/ }),
/* 8 */
/***/ (function(module, exports) {

module.exports = "{{ multilineComment description }}\nenum {{name}} {\n  {{#each values }}{{value}},{{#unless @last}}\n  {{/unless}}{{/each}}\n}\n"

/***/ }),
/* 9 */
/***/ (function(module, exports) {

module.exports = "{{#unless (\n  ignoreType\n    name\n      @root.config.replaceTypes\n      typeName\n      @root.config.irreducibleTypes\n)}}\n{{ multilineComment description }}\n{{> defineClass this className=name }}\n\n{{#each fields}}{{# if hasArguments }}\n{{> defineClass this\n  fields=arguments\n  className=(concat ../name (toPascalCase name) \"Args\")\n}}\n{{/if}}{{/each}}\n{{/unless}}\n"

/***/ }),
/* 10 */
/***/ (function(module, exports) {

module.exports = "{{# if (hackFragmentFields \"ensure_unique\" name) ~}}\n\n{{#eachBackwards innerModels }}\n\n{{> defineClass\n      className=(concat (toPascalCase ../name) modelType)\n      typeName=schemaBaseType\n      assignableTo=(\n        withInputType\n          schemaBaseType\n          @root.config.replaceTypes\n          (concat (toPascalCase ../name) modelType)\n          @root.config.generateFragmentHelpers\n      )\n      fields=(hackFragmentFields \"get\" fragmentsSpread fields )\n      contextModels=../innerModels\n      contextName=(toPascalCase ../name)\n}}\n\n\n{{/eachBackwards}}\n\n{{> defineClass\n      className=(concat (toPascalCase name) '')\n      typeName=onType\n      assignableTo=(\n        withInputType\n          onType\n          @root.config.replaceTypes\n          (concat (toPascalCase name) '')\n          @root.config.generateFragmentHelpers\n      )\n      fields=(hackFragmentFields \"get\" fragmentsSpread fields)\n      contextModels=innerModels\n      contextName=(toPascalCase name)\n}}\n\n{{~ hackFragmentFields \"add\" name\n    fields\n    innerModels\n    fragmentsSpread \n~}}\n\n{{/if}}\n"

/***/ }),
/* 11 */
/***/ (function(module, exports) {

module.exports = "{{> defineClass\n  fields=variables\n  className=(concat (toPascalCase name) \"Variables\")\n}}\n\n{{#eachBackwards innerModels }}\n{{> defineClass\n      fields=(hackFragmentFields \"get\" fragmentsSpread fields )\n      className=(concat (toPascalCase ../name) modelType)\n      typeName=schemaBaseType\n      contextModels=../innerModels\n      contextName=(toPascalCase ../name)\n}}\n\n\n{{/eachBackwards}}\n\n{{> defineClass\n      fields=(hackFragmentFields \"get\" fragmentsSpread fields )\n      className=(concat (toPascalCase name) (toPascalCase operationType))\n      typeName=(concat (toPascalCase name) (toPascalCase operationType))\n      contextModels=innerModels\n      contextName=(toPascalCase name)\n}}\n\n"

/***/ }),
/* 12 */
/***/ (function(module, exports) {

module.exports = "// GENERATED CODE - DO NOT MODIFY BY HAND\n\nimport 'package:meta/meta.dart';\nimport 'package:json_annotation/json_annotation.dart';\n\n{{#if config.imports}}\n{{#each config.imports}}\nimport '{{this}}';\n{{/each}}\n{{/if}}\n\n{{#if config.parts}}\n{{#each config.parts}}\npart '{{this}}';\n{{/each}}\n{{/if}}\n\n/* Enums */\n{{#each enums}}\n{{> enum }}\n\n{{/each}}\n\nabstract class ToJson {\n  Map<String, dynamic> toJson();\n}\n\n{{#each unions}}\n// TODO I don't think unions are possible with dart\n// perhaps https://github.com/fluttercommunity/dart_sealed_unions\n// Please PR if you need unions\n{{ toComment description }}\n{{/each}}\n\n/* Input Types */\n{{#each inputTypes}}\n{{> type }}\n{{~ registerInputType name }}\n\n{{/each}}\n\n/* Interfaces */\n{{#each interfaces}}\n{{> type }}\n\n{{/each}}\n\n/* Types */\n{{#each types}}\n{{> type }}\n\n{{/each}}\n{{!--\n{{~#each types}}\n  {{~#each fields}}\n    {{~# if hasArguments }}\nexport interface {{ toPascalCase name }}{{ toPascalCase ../name }}Args {\n{{#each arguments}}\n  {{ name }}{{ getOptionals this }}: {{ convertedType this }}; {{ toComment description }}\n{{/each}}\n}\n    {{/if}}\n  {{/each}}\n{{/each}}\n--}}\n\n"

/***/ }),
/* 13 */
/***/ (function(module, exports) {

module.exports = "{{#each fragments }}\n{{> fragment }}\n\n{{/each}}\n\n{{#each operations}}\n{{> operation }}\n{{/each}}\n\n"

/***/ }),
/* 14 */
/***/ (function(module, exports) {

module.exports = "{{#if config.printTime }}\n/** Generated in {{ currentTime }} */\n{{/if}}\n{{> schema }}\n{{> documents }}\n"

/***/ }),
/* 15 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var multiline_comment_1 = __webpack_require__(16);
exports.multilineComment = multiline_comment_1.default;
var class_extends_1 = __webpack_require__(18);
exports.classExtends = class_extends_1.default;
var resolve_type_1 = __webpack_require__(19);
exports.resolveType = resolve_type_1.default;
var resolve_mixins_1 = __webpack_require__(20);
exports.resolveMixins = resolve_mixins_1.default;
var hack_fragment_fields_1 = __webpack_require__(21);
exports.hackFragmentFields = hack_fragment_fields_1.default;
var ignore_type_1 = __webpack_require__(22);
exports.ignoreType = ignore_type_1.default;
var with_input_type_1 = __webpack_require__(23);
exports.withInputType = with_input_type_1.default;
exports.registerInputType = with_input_type_1.registerInputType;
var fragment_field_on_base_type_1 = __webpack_require__(2);
exports.fragmentFieldOnBaseType = fragment_field_on_base_type_1.default;
var utils_1 = __webpack_require__(0);
exports.log = utils_1.log;
exports.logThis = utils_1.logThis;
exports.concat = utils_1.concat;
exports.eachBackwards = utils_1.eachBackwards;
exports.takeFirst = utils_1.takeFirst;
exports.stripSuffix = utils_1.stripSuffix;


/***/ }),
/* 16 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return multilineComment; });
const linewrap = __webpack_require__(17)
const { SafeString } = __webpack_require__(1)
const wrap = linewrap(80, {
  wrapLineIndent: 0,
  lineBreak: '\n/// '
})
function multilineComment (comment = '') {
  return new SafeString(`/// ${wrap(comment)}`)
}


/***/ }),
/* 17 */
/***/ (function(module, exports) {

module.exports = require("linewrap");

/***/ }),
/* 18 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return classExtends; });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);


const fragmentClass = f => Object(_utils__WEBPACK_IMPORTED_MODULE_0__["capitalize"])(f.fragmentName)

const builtinInterfaces = ['ToJson']

// TODO inline fragment "onType" support
// we extend from interfaces in dart to allow functionality 
// piggybacking via replaceTypes
// TODO base type / entity modeling
//   should be done via postgraphile plugin
//   right now we replace Node with Entity, which is hacky
//   ex. Query becomes an "Entity"
function classExtends(
  [base, ...mixins] = [],
  fragments = [],
  interfaces = [],
  replace = {}
) {
  return (base ? `extends ${base} ` : '') + (
    mixins.length ? `with ${mixins.join(', ')} ` : ''
  ) + `implements ${
        builtinInterfaces
          .concat(interfaces)
          .concat(fragments.map(fragmentClass))
        .join(', ')
  }`
}



/***/ }),
/* 19 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return resolveType; });
const { SafeString } = __webpack_require__(1)

const primitives = {
  String: 'String',
  Int: 'int',
  Float: 'double',
  Boolean: 'bool',
  ID: 'String',

  int: 'int',
  bool: 'bool',
  double: 'double',
  num: 'num',
  dynamic: 'dynamic',

  Object: 'Object',
  DateTime: 'DateTime'
}

function serializers(type){
  return `@JsonKey(fromJson: fromJsonTo${type}, toJson: from${type}ToJson)
  `
}

function wrap(isArray, fieldType){
  return isArray ? `List<${fieldType}>` : fieldType
}

function resolveType(
  type,
  contextName,
  contextModels = [],
  scalars = {},
  replace = {},
  isArray,
  irreducibles = [],
  rawTypeText
) {
  if (irreducibles.includes(rawTypeText.replace('!',''))) {
    return rawTypeText.replace('!','')
  }

  let fieldType = contextModels.filter(({ modelType }) => modelType === type).length
    ?  contextName + type
    : (primitives[type] || type || 'Object')

  if (replace[fieldType]){
    fieldType = replace[fieldType]
  }
  if (scalars[fieldType]){
    fieldType = scalars[fieldType]
    if (!(fieldType in primitives)) {
      return new SafeString(serializers(fieldType) + wrap(isArray, fieldType))
    } else {
      fieldType = primitives[fieldType]
    }
  }
  return new SafeString(wrap(isArray, fieldType))
}



/***/ }),
/* 20 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return resolveMixins; });
function resolveMixins(
  mixins = [],
  fields = []
) {
  let fieldNames = fields.map(f => f.name);
  return mixins.filter(({ when = { fields: [] } }) => {
    for (let requiredField of when.fields){
      if (!fieldNames.includes(requiredField)){
        return false
      }
    }
    return true
  }).map(mixin => mixin.name)
}



/***/ }),
/* 21 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return hackFragmentFields; });
/* harmony import */ var _utils__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);


var fragmentFields = {
};

function getFields(name){
  let { nestedFragments, fields, ...context } = fragmentFields[name]
  fields = fields.map(field => Object.assign(field, context))
  nestedFragments.forEach(nested => {
    fields = fields.concat(getFields(nested))
  })
  return fields
}
// Grab fragments and add them to inhereting classes
function hackFragmentFields(action, nameOrFragments, fields, contextModels, nestedFragments = []){

  if (action === 'ensure_unique'){
    const name = nameOrFragments
    return !(name in fragmentFields)
  }
  
  if (action === 'add'){
    const name = nameOrFragments
    fragmentFields[name] = {
      contextName: Object(_utils__WEBPACK_IMPORTED_MODULE_0__["capitalize"])(name),
      contextModels,
      nestedFragments: nestedFragments.map(f => f.fragmentName),
      fields
    }
  }

  if (action === 'get'){
    const fragments = nameOrFragments
    return [
      ...fields,
      ...fragments.reduce((fragFields, frag) =>
        fragFields.concat(getFields(frag.fragmentName)), [])
    ]
  }

}



/***/ }),
/* 22 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return ignoreType; });
function ignoreType(
  name,
  ignore = {},
  baseType,
  irreducibles
) {
  return Object.keys(ignore).includes(name) || (
    baseType && irreducibles.includes(baseType)
  )
}



/***/ }),
/* 23 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "registerInputType", function() { return registerInputType; });
/* harmony export (binding) */ __webpack_require__.d(__webpack_exports__, "default", function() { return withInputType; });
/* harmony import */ var _fragment_field_on_base_type__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(2);
 

function typeReplacer(replace){
  return type => replace[type] || type
}

var inputTypes = []

function registerInputType(inputType){
  inputTypes.push(inputType)
}


function shouldExcludeOnType(baseType, config){
  for (let exclude of config.excludeFields || []){
    if (exclude.onType === baseType){
      return true
    }
  }
  return false
}


function withInputType(
  baseType,
  replaceMap,
  className,
  exclusionConfig
) {
  if (exclusionConfig && (
      !Object(_fragment_field_on_base_type__WEBPACK_IMPORTED_MODULE_0__["shouldBeIncluded"])(className, exclusionConfig) ||
      shouldExcludeOnType(baseType, exclusionConfig)
  )){
    return []
  }

  const replace = typeReplacer(replaceMap)

  baseType = replace(baseType)

  const inputType = replace(`${baseType}Input`)

  if (
    (!inputTypes.includes(inputType)) ||
    inputType === baseType
  ){
    return [baseType]
  }

  return [baseType, inputType]

}


/***/ })
/******/ ])));
//# sourceMappingURL=index.js.map